diff -r -uw -N irrlicht/source/Irrlicht/CSkyBoxSceneNode.h irrlicht_multipatch/source/Irrlicht/CSkyBoxSceneNode.h
--- irrlicht/source/Irrlicht/CSkyBoxSceneNode.h	2006-08-13 14:44:42.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CSkyBoxSceneNode.h	2006-11-29 23:36:52.000000000 +0100
@@ -50,7 +50,7 @@
 	private:
 
 		core::aabbox3d<f32> Box;
-		u16 Indices[4];
+		u32 Indices[4];
 		video::S3DVertex Vertices[4*6];
 		video::SMaterial Material[6];
 	};
diff -r -uw -N irrlicht/source/Irrlicht/CSoftwareDriver.cpp irrlicht_multipatch/source/Irrlicht/CSoftwareDriver.cpp
--- irrlicht/source/Irrlicht/CSoftwareDriver.cpp	2006-11-01 12:04:00.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CSoftwareDriver.cpp	2006-12-05 11:50:58.000000000 +0100
@@ -164,7 +164,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool CSoftwareDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool CSoftwareDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	switch (feature)
 	{
@@ -316,10 +316,10 @@
 
 
 //! draws a vertex primitive list
-void CSoftwareDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void CSoftwareDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
-	const u16* indexPointer=0;
-	core::array<u16> newBuffer;
+	const u32* indexPointer=0;
+	core::array<u32> newBuffer;
 	switch (pType)
 	{
 		case scene::EPT_TRIANGLE_FAN:
@@ -357,7 +357,7 @@
 
 template<class VERTEXTYPE>
 void CSoftwareDriver::drawClippedIndexedTriangleListT(const VERTEXTYPE* vertices,
-	s32 vertexCount, const u16* indexList, s32 triangleCount)
+	s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	if (!RenderTargetSurface || !ZBuffer || !triangleCount)
 		return;
@@ -367,7 +367,7 @@
 
 	// arrays for storing clipped vertices
 	core::array<VERTEXTYPE> clippedVertices;
-	core::array<u16> clippedIndices;
+	core::array<u32> clippedIndices;
 
 	// calculate inverse world transformation
 	core::matrix4 worldinv(TransformationMatrix[ETS_WORLD]);
@@ -612,7 +612,7 @@
 	vtx[2].Pos = start + vect;
 	vtx[3].Pos = end + vect;
 
-	u16 idx[12] = {0,1,2, 0,2,1, 0,1,3, 0,3,1};
+	u32 idx[12] = {0,1,2, 0,2,1, 0,1,3, 0,3,1};
 
 	drawIndexedTriangleList(vtx, 4, idx, 4);
 }
diff -r -uw -N irrlicht/source/Irrlicht/CSoftwareDriver.h irrlicht_multipatch/source/Irrlicht/CSoftwareDriver.h
--- irrlicht/source/Irrlicht/CSoftwareDriver.h	2006-10-15 08:48:46.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CSoftwareDriver.h	2006-12-05 11:48:24.000000000 +0100
@@ -28,7 +28,7 @@
 		virtual bool endScene( s32 windowId = 0, core::rect<s32>* sourceRect=0 );
 
 		//! queries the features of the driver, returns true if feature is available
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! sets transformation
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
@@ -46,7 +46,7 @@
 		virtual bool beginScene(bool backBuffer, bool zBuffer, SColor color);
 
 		//! draws a vertex primitive list
-		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! Draws a 3d line.
 		virtual void draw3DLine(const core::vector3df& start,
@@ -121,7 +121,7 @@
 
 		template<class VERTEXTYPE>
 		void drawClippedIndexedTriangleListT(const VERTEXTYPE* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount);
+			s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		core::array<S2DVertex> TransformedPoints;
 
diff -r -uw -N irrlicht/source/Irrlicht/CSoftwareDriver2.cpp irrlicht_multipatch/source/Irrlicht/CSoftwareDriver2.cpp
--- irrlicht/source/Irrlicht/CSoftwareDriver2.cpp	2006-10-15 08:48:46.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CSoftwareDriver2.cpp	2006-12-05 11:54:19.000000000 +0100
@@ -235,7 +235,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool CSoftwareDriver2::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool CSoftwareDriver2::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	switch (feature)
 	{
@@ -819,7 +819,7 @@
 }
 
 //! draws a vertex primitive list
-void CSoftwareDriver2::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void CSoftwareDriver2::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
 	if (!checkPrimitiveCount(primitiveCount))
 		return;
diff -r -uw -N irrlicht/source/Irrlicht/CSoftwareDriver2.h irrlicht_multipatch/source/Irrlicht/CSoftwareDriver2.h
--- irrlicht/source/Irrlicht/CSoftwareDriver2.h	2006-11-18 08:23:10.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CSoftwareDriver2.h	2006-12-05 11:54:29.000000000 +0100
@@ -30,7 +30,7 @@
 		virtual bool endScene( s32 windowId = 0, core::rect<s32>* sourceRect=0 );
 
 		//! queries the features of the driver, returns true if feature is available
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! sets transformation
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
@@ -62,7 +62,7 @@
 		virtual void setAmbientLight(const SColorf& color);
 
 		//! draws a vertex primitive list
-		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! draws an 2d image, using a color (if color is other then Color(255,255,255,255)) and the alpha channel of the texture if wanted.
 		virtual void draw2DImage(video::ITexture* texture, const core::position2d<s32>& destPos,
diff -r -uw -N irrlicht/source/Irrlicht/CTRFlat.cpp irrlicht_multipatch/source/Irrlicht/CTRFlat.cpp
--- irrlicht/source/Irrlicht/CTRFlat.cpp	2006-11-01 09:51:50.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRFlat.cpp	2006-11-29 23:58:06.000000000 +0100
@@ -22,7 +22,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRFlatWire.cpp irrlicht_multipatch/source/Irrlicht/CTRFlatWire.cpp
--- irrlicht/source/Irrlicht/CTRFlatWire.cpp	2006-11-01 09:51:42.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRFlatWire.cpp	2006-11-29 23:58:20.000000000 +0100
@@ -22,7 +22,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRGouraud.cpp irrlicht_multipatch/source/Irrlicht/CTRGouraud.cpp
--- irrlicht/source/Irrlicht/CTRGouraud.cpp	2006-11-01 11:47:58.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRGouraud.cpp	2006-11-29 23:59:00.000000000 +0100
@@ -23,7 +23,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRGouraudWire.cpp irrlicht_multipatch/source/Irrlicht/CTRGouraudWire.cpp
--- irrlicht/source/Irrlicht/CTRGouraudWire.cpp	2006-11-01 09:51:26.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRGouraudWire.cpp	2006-11-29 23:59:00.000000000 +0100
@@ -22,7 +22,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRTextureFlat.cpp irrlicht_multipatch/source/Irrlicht/CTRTextureFlat.cpp
--- irrlicht/source/Irrlicht/CTRTextureFlat.cpp	2006-11-01 09:52:02.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRTextureFlat.cpp	2006-11-29 23:59:00.000000000 +0100
@@ -22,7 +22,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRTextureFlatWire.cpp irrlicht_multipatch/source/Irrlicht/CTRTextureFlatWire.cpp
--- irrlicht/source/Irrlicht/CTRTextureFlatWire.cpp	2006-11-01 09:51:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRTextureFlatWire.cpp	2006-11-29 23:59:00.000000000 +0100
@@ -22,7 +22,7 @@
 	}
 
 	//! draws an indexed triangle list
-	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+	virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 	{
 		const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRTextureGouraud.cpp irrlicht_multipatch/source/Irrlicht/CTRTextureGouraud.cpp
--- irrlicht/source/Irrlicht/CTRTextureGouraud.cpp	2006-11-01 11:55:30.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRTextureGouraud.cpp	2006-11-29 23:59:00.000000000 +0100
@@ -89,7 +89,7 @@
 
 
 //! draws an indexed triangle list
-void CTRTextureGouraud::drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+void CTRTextureGouraud::drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	const S2DVertex *v1, *v2, *v3;
 
diff -r -uw -N irrlicht/source/Irrlicht/CTRTextureGouraud.h irrlicht_multipatch/source/Irrlicht/CTRTextureGouraud.h
--- irrlicht/source/Irrlicht/CTRTextureGouraud.h	2006-11-01 09:50:00.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CTRTextureGouraud.h	2006-11-29 23:59:24.000000000 +0100
@@ -27,7 +27,7 @@
 		virtual void setRenderTarget(video::IImage* surface, const core::rect<s32>& viewPort);
 
 		//! draws an indexed triangle list
-		virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount);
+		virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! en or disables the backface culling
 		virtual void setBackfaceCulling(bool enabled = true);
diff -r -uw -N irrlicht/source/Irrlicht/CTerrainSceneNode.cpp irrlicht_multipatch/source/Irrlicht/CTerrainSceneNode.cpp
--- irrlicht/source/Irrlicht/CTerrainSceneNode.cpp	2006-10-15 08:48:50.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CTerrainSceneNode.cpp	2006-12-01 14:45:40.000000000 +0100
@@ -548,6 +548,13 @@
 		return TerrainData.Patches[patchX * TerrainData.PatchCount + patchZ].BoundingBox;
 	}
 
+	//!destroy the mesh buffer
+	void CTerrainSceneNode::destroyMeshBuffer(SMeshBufferLightMap& mb)
+	{
+		mb.Indices.clear();
+		mb.Vertices.clear();
+	}
+
 	//! Gets the meshbuffer data based on a specified Level of Detail.
 	//! \param mb: A reference to an SMeshBuffer object
 	//! \param LOD: The Level Of Detail you want the indices from.
diff -r -uw -N irrlicht/source/Irrlicht/CTerrainSceneNode.h irrlicht_multipatch/source/Irrlicht/CTerrainSceneNode.h
--- irrlicht/source/Irrlicht/CTerrainSceneNode.h	2006-09-24 11:30:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CTerrainSceneNode.h	2006-12-01 14:45:46.000000000 +0100
@@ -136,6 +136,9 @@
 		//! Returns the mesh
 		virtual IMesh* getMesh() { return &Mesh; }
 
+		//!a helper function to destroy the meshbuffer.
+		void destroyMeshBuffer(SMeshBufferLightMap& mb);
+
 		//! Gets the meshbuffer data based on a specified Level of Detail.
 		//! \param mb: A reference to an SMeshBufferLightMap object
 		//! \param LOD: The Level Of Detail you want the indices from.
diff -r -uw -N irrlicht/source/Irrlicht/CTriangleSelector.cpp irrlicht_multipatch/source/Irrlicht/CTriangleSelector.cpp
--- irrlicht/source/Irrlicht/CTriangleSelector.cpp	2006-07-15 08:41:46.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CTriangleSelector.cpp	2006-11-29 23:43:46.000000000 +0100
@@ -34,7 +34,7 @@
 		IMeshBuffer* buf = mesh->getMeshBuffer(i);
 
 		s32 idxCnt = buf->getIndexCount();
-		const u16* indices = buf->getIndices();
+		const u32* indices = buf->getIndices();
 		core::triangle3df tri;
 
 		switch (buf->getVertexType())
diff -r -uw -N irrlicht/source/Irrlicht/CXAnimationPlayer.cpp irrlicht_multipatch/source/Irrlicht/CXAnimationPlayer.cpp
--- irrlicht/source/Irrlicht/CXAnimationPlayer.cpp	2006-11-01 08:12:56.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CXAnimationPlayer.cpp	2006-12-05 17:54:08.000000000 +0100
@@ -205,10 +205,17 @@
 	
 	if (xmat.TextureFileName.size() != 0)
 	{
+		
+		if(getTextureFileName(xmat.TextureFileName).size() > 0)
+		{
 		mat.Texture1 = Driver->getTexture(getTextureFileName(xmat.TextureFileName).c_str());
+		}
+
 		if (mat.Texture1 == 0)
+		{
 			mat.Texture1 = Driver->getTexture(xmat.TextureFileName.c_str());
 	}
+	}
 
 	return mat;
 }
diff -r -uw -N irrlicht/source/Irrlicht/ITriangleRenderer.h irrlicht_multipatch/source/Irrlicht/ITriangleRenderer.h
--- irrlicht/source/Irrlicht/ITriangleRenderer.h	2006-06-17 08:11:56.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/ITriangleRenderer.h	2006-11-29 23:57:48.000000000 +0100
@@ -49,7 +49,7 @@
 		virtual void setTexture(video::IImage* texture) = 0;
 
 		//! draws an indexed triangle list
-		virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+		virtual void drawIndexedTriangleList(S2DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 	};
 
 
diff -r -uw -N irrlicht/source/Irrlicht/Irrlicht.dev irrlicht_multipatch/source/Irrlicht/Irrlicht.dev
--- irrlicht/source/Irrlicht/Irrlicht.dev	2006-11-04 09:42:22.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/Irrlicht.dev	2006-12-05 12:56:03.452832587 +0100
@@ -9,7 +9,7 @@
 Includes=..\..\include;zlib
 Linker=-lkernel32 -luser32 -lgdi32 -lwinspool -lcomdlg32 -ladvapi32 -lshell32 -lole32 -loleaut32 -luuid -lodbc32 -lodbccp32 -lglu32 -lopengl32_@@_
 Libs=
-UnitCount=497
+UnitCount=499
 Folders=doc,gui_impl,include,include/core,include/gui,include/io,include/scene,include/video,io_impl,other_impl,other_impl/extern,other_impl/extern/jpeglib,other_impl/extern/libpng,other_impl/extern/zlib,scene_impl,video_impl,video_impl/DirectX8,video_impl/DirectX9,video_impl/Null,video_impl/OpenGL,video_impl/Software,video_impl/Software2
 ObjFiles=
 PrivateResource=
@@ -5015,3 +5015,22 @@
 OverrideBuildCmd=0
 BuildCmd=
 
+[Unit498]
+FileName=CD3D9MDriver.cpp
+Folder=video_impl/DirectX9
+Compile=1
+CompileCpp=1
+Link=1
+Priority=1000
+OverrideBuildCmd=0
+BuildCmd=
+
+[Unit499]
+FileName=CD3D9MDriver.h
+Folder=video_impl/DirectX9
+Compile=1
+CompileCpp=1
+Link=1
+Priority=1000
+OverrideBuildCmd=0
+BuildCmd=
diff -r -uw -N irrlicht/source/Irrlicht/Irrlicht7.1.vcproj irrlicht_multipatch/source/Irrlicht/Irrlicht7.1.vcproj
--- irrlicht/source/Irrlicht/Irrlicht7.1.vcproj	2006-11-01 11:17:48.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/Irrlicht7.1.vcproj	2006-12-05 12:50:18.087271661 +0100
@@ -500,9 +500,6 @@
 					RelativePath=".\..\..\include\ISceneNodeFactory.h">
 				</File>
 				<File
-					RelativePath=".\..\..\include\ISceneNodeMeshLoader.h">
-				</File>
-				<File
 					RelativePath=".\..\..\include\IShadowVolumeSceneNode.h">
 				</File>
 				<File
@@ -1040,6 +1037,12 @@
 					RelativePath=".\CD3D9MaterialRenderer.h">
 				</File>
 				<File
+					RelativePath=".\CD3D9MDriver.cpp">
+				</File>
+				<File
+					RelativePath=".\CD3D9MDriver.h">
+				</File>
+				<File
 					RelativePath=".\CD3D9NormalMapRenderer.cpp">
 				</File>
 				<File
diff -r -uw -N irrlicht/source/Irrlicht/Irrlicht8.0.vcproj irrlicht_multipatch/source/Irrlicht/Irrlicht8.0.vcproj
--- irrlicht/source/Irrlicht/Irrlicht8.0.vcproj	2006-11-04 09:42:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/Irrlicht8.0.vcproj	2006-12-05 12:52:43.747982245 +0100
@@ -1263,6 +1263,12 @@
 					>
 				</File>
 				<File
+					RelativePath=".\CD3D9MDriver.cpp">
+				</File>
+				<File
+					RelativePath=".\CD3D9MDriver.h">
+				</File>
+				<File
 					RelativePath=".\CD3D9NormalMapRenderer.cpp"
 					>
 				</File>
diff -r -uw -N irrlicht/source/Irrlicht/OctTree.h irrlicht_multipatch/source/Irrlicht/OctTree.h
--- irrlicht/source/Irrlicht/OctTree.h	2006-11-18 08:23:10.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/OctTree.h	2006-11-30 10:56:46.000000000 +0100
@@ -26,19 +26,19 @@
 	struct SMeshChunk
 	{
 		core::array<T> Vertices;
-		core::array<u16> Indices;
+		core::array<u32> Indices;
 		s32 MaterialId;
 	};
 
 	struct SIndexChunk
 	{
-		core::array<u16> Indices;
+		core::array<u32> Indices;
 		s32 MaterialId;
 	};
 
 	struct SIndexData
 	{
-		u16* Indices;
+		u32* Indices;
 		s32 CurrentSize;
 		s32 MaxSize;
 	};
@@ -62,7 +62,7 @@
 		{
 			IndexData[i].CurrentSize = 0;
 			IndexData[i].MaxSize = meshes[i].Indices.size();
-			IndexData[i].Indices = new u16[IndexData[i].MaxSize];
+			IndexData[i].Indices = new u32[IndexData[i].MaxSize];
 
 			ic.MaterialId = meshes[i].MaterialId;
 			(*indexChunks).push_back(ic);
@@ -267,8 +267,7 @@
 
 					if (idxcnt)
 					{
-						memcpy(&idxdata[i].Indices[idxdata[i].CurrentSize], 
-							&(*IndexData)[i].Indices[0], idxcnt * sizeof(s16));
+						memcpy(&idxdata[i].Indices[idxdata[i].CurrentSize], &(*IndexData)[i].Indices[0], idxcnt * sizeof(s32));
 						idxdata[i].CurrentSize += idxcnt;
 					}
 				}
@@ -320,8 +319,7 @@
 
 					if (idxcnt)
 					{
-						memcpy(&idxdata[i].Indices[idxdata[i].CurrentSize], 
-							&(*IndexData)[i].Indices[0], idxcnt * sizeof(s16));
+						memcpy(&idxdata[i].Indices[idxdata[i].CurrentSize],	&(*IndexData)[i].Indices[0], idxcnt * sizeof(s32));
 						idxdata[i].CurrentSize += idxcnt;
 					}
 				}
